#!/usr/bin/env python
#
# AIEngine.
#
# Copyright (C) 2013-2014  Luis Campo Giralte
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
# Boston, MA  02110-1301, USA.
#
# Written by Luis Campo Giralte <luis.camp0.2009@gmail.com> 
#
""" Example for analyse URIs over a given domain to monitor """
__author__ = "Luis Campo Giralte"
__copyright__ = "Copyright (C) 2013-2014 by Luis Campo Giralte"
__revision__ = "$Id$"
__version__ = "0.1"
import sys
import os
import base64
import glob
sys.path.append("../src/")
import pyaiengine

def callback_uri(flow):

    ip = str(flow).split(":")[0]

    h = flow.getHTTPInfo()
    if (h):
        uri = str(h.getUri())
        if (uri):
            if ((uri.startswith("http") == False)and(uri[0] != "/")):
                if (uri.find('%') >= 0):
                    # The URI is encoded, so decode for analysis
                    try:
                        urie = base64.b64decode(uri)
                        print "Original:",uri
                        print "Decoded:",urie
                    except:
                        pass 

if __name__ == '__main__':

    # Load an instance of a Network Stack on Lan network
    st = pyaiengine.StackMobile()

    # Create a instace of a PacketDispatcher
    pdis = pyaiengine.PacketDispatcher()

    # Plug the stack on the PacketDispatcher
    pdis.setStack(st)

    dm = pyaiengine.DomainNameManager()

    dom = pyaiengine.DomainName("Service to analyze",
        "facebook.com")
    dom.setCallback(callback_uri)
    dm.addDomainName(dom)
    
    st.setHTTPHostNameManager(dm)

    st.setTotalTCPFlows(327680)
    st.setTotalUDPFlows(163840)

    files = glob.glob("/home/luis/pcapfiles/*.pcap")
    for f in files:
        pdis.open(f)

        pdis.run()

    pdis.close()

    sys.exit(0)

